<script lang="ts">
  import { faChevronDown, faChevronRight } from '@fortawesome/free-solid-svg-icons';
  import Fa from 'svelte-fa';
  import { useLocalStorage } from 'sveltronics';

  export let label: string = '';
  export let labelTextColor = 'white';
  export let labelBgColor = 'black';
  export let borderColor = 'white';
  export let collapsable = false;

  // unique ID to remember collapsed status. Default is to generate based on parameters
  export let id = btoa(`${label}:${labelTextColor}:${labelBgColor}:${borderColor}`);
  const _collapsed = useLocalStorage(`labeledContainer:collapsed:${id}`, false);
  $: _collapsed.set(collapsed);

  export let collapsed = $_collapsed;
</script>

<div
  class="labeled-container-wrapper my-4 pt-1"
  style="--label-text-color: {labelTextColor}; --label-bg-color: {labelBgColor}; --border-color: {borderColor};"
>
  <div class="labeled-container-label">
    <slot {collapsable} {collapsed} {borderColor} {labelTextColor} {labelBgColor} name="label">
      {#if collapsable}
        <button class="clickable" on:click={() => (collapsed = !collapsed)}>
          <Fa class="d-inline-block" icon={collapsed ? faChevronRight : faChevronDown} />
          {label}
        </button>
      {:else}
        {label}
      {/if}
    </slot>
  </div>
  <div class="labeled-container-content" class:mh-0={collapsed} style="max-height: {collapsed ? 0 : 'unset'}">
    <div class="p-2 pt-3">
      <slot />
    </div>
  </div>
</div>

<style>
  .labeled-container-wrapper {
    position: relative;
  }
  .labeled-container-label {
    position: absolute;
    top: 0.2ex;
    z-index: 1;
    left: 2em;
    color: var(--label-text-color, white);
    background-color: var(--label-bg-color, black);
    padding: 0 5px;
  }
  .labeled-container-content {
    border: 1px solid var(--border-color, white);
    border-radius: 6px;
    position: relative;
    margin-top: 10px;
    overflow: clip;
  }
</style>
